<?
use Bitrix\Main\Type\Collection;
use Bitrix\Currency\CurrencyTable;
use Bitrix\Iblock;

\Bitrix\Main\Loader::registerAutoLoadClasses(null, [
    "\\CatalogTagsFilter" => '/local/php_interface/include/custom/CatalogTagsFilter.php',
    "\\IBlockElementPropertyTable" => '/local/php_interface/include/custom/IBlockElementPropertyTable.php'
]);
/*start: seo tags*/
\Bitrix\Main\EventManager::getInstance()->addEventHandler('main', 'OnPageStart', ['CatalogTagsFilter', 'OnPageStartRedirect'] );
/*end: seo tags*/

function declension($n,$s1,$s2,$s3){
    $m = $n % 10; $j = $n % 100;
    if($m==0 || $m>=5 || ($j>=10 && $j<=20)) return $s3;
    if($m>=2 && $m<=4) return  $s2;
    return $s1;
}

//AddEventHandler("iblock", "OnAfterIBlockElementUpdate", "DoIBlockAfterSave");
//AddEventHandler("iblock", "OnAfterIBlockElementAdd", "DoIBlockAfterSave");
AddEventHandler("catalog", "OnPriceAdd", "DoIBlockAfterSave");
AddEventHandler("catalog", "OnPriceUpdate", "DoIBlockAfterSave");

function DoIBlockAfterSave($arg1, $arg2 = false)
{
	$ELEMENT_ID = false;
	$IBLOCK_ID = false;
	$OFFERS_IBLOCK_ID = false;
	$OFFERS_PROPERTY_ID = false;
	if (CModule::IncludeModule('currency'))
	$strDefaultCurrency = CCurrency::GetBaseCurrency();

	//Check for catalog event
	if(is_array($arg2) && $arg2["PRODUCT_ID"] > 0)
	{
		//Get iblock element
		$rsPriceElement = CIBlockElement::GetList(
			array(),
			array(
			"ID" => $arg2["PRODUCT_ID"],
			),
			false,
			false,
			array("ID", "IBLOCK_ID")
		);
		if($arPriceElement = $rsPriceElement->Fetch())
		{
			$arCatalog = CCatalog::GetByID($arPriceElement["IBLOCK_ID"]);
			if(is_array($arCatalog))
			{
				//Check if it is offers iblock
				if($arCatalog["OFFERS"] == "Y")
				{
					//Find product element
					$rsElement = CIBlockElement::GetProperty(
						$arPriceElement["IBLOCK_ID"],
						$arPriceElement["ID"],
						"sort",
						"asc",
						array("ID" => $arCatalog["SKU_PROPERTY_ID"])
					);
					$arElement = $rsElement->Fetch();
					if($arElement && $arElement["VALUE"] > 0)
					{
						$ELEMENT_ID = $arElement["VALUE"];
						$IBLOCK_ID = $arCatalog["PRODUCT_IBLOCK_ID"];
						$OFFERS_IBLOCK_ID = $arCatalog["IBLOCK_ID"];
						$OFFERS_PROPERTY_ID = $arCatalog["SKU_PROPERTY_ID"];
					}
				}
				//or iblock which has offers
				elseif($arCatalog["OFFERS_IBLOCK_ID"] > 0)
				{
				$ELEMENT_ID = $arPriceElement["ID"];
				$IBLOCK_ID = $arPriceElement["IBLOCK_ID"];
				$OFFERS_IBLOCK_ID = $arCatalog["OFFERS_IBLOCK_ID"];
				$OFFERS_PROPERTY_ID = $arCatalog["OFFERS_PROPERTY_ID"];
				}
				//or it's regular catalog
				else
				{
				$ELEMENT_ID = $arPriceElement["ID"];
				$IBLOCK_ID = $arPriceElement["IBLOCK_ID"];
				$OFFERS_IBLOCK_ID = false;
				$OFFERS_PROPERTY_ID = false;
				}
			}
		}
	}
	//Check for iblock event
	elseif(is_array($arg1) && $arg1["ID"] > 0 && $arg1["IBLOCK_ID"] > 0)
	{
		//Check if iblock has offers
		$arOffers = CIBlockPriceTools::GetOffersIBlock($arg1["IBLOCK_ID"]);
		if(is_array($arOffers))
		{
			$ELEMENT_ID = $arg1["ID"];
			$IBLOCK_ID = $arg1["IBLOCK_ID"];
			$OFFERS_IBLOCK_ID = $arOffers["OFFERS_IBLOCK_ID"];
			$OFFERS_PROPERTY_ID = $arOffers["OFFERS_PROPERTY_ID"];
		}
	}


	if($ELEMENT_ID)
	{
		static $arPropCache = array();
		if(!array_key_exists($IBLOCK_ID, $arPropCache))
	{
		//Check for MINIMAL_PRICE property
		$rsProperty = CIBlockProperty::GetByID("SORT_PRICE", $IBLOCK_ID);
		$arProperty = $rsProperty->Fetch();
		if($arProperty)
		$arPropCache[$IBLOCK_ID] = $arProperty["ID"];
		else
		$arPropCache[$IBLOCK_ID] = false;
	}

	if($arPropCache[$IBLOCK_ID])
	{
		$arProductID = "";
		//Compose elements filter
		if($OFFERS_IBLOCK_ID)
		{
			
			$rsOffers = CIBlockElement::GetList(
				array(),
				array(
					"ACTIVE" => "Y",
					"IBLOCK_ID" => $OFFERS_IBLOCK_ID,
					"PROPERTY_".$OFFERS_PROPERTY_ID => $ELEMENT_ID,
				),
				false,
				false,
				array("ID", "IBLOCK_ID", "PROPERTY_*")
			);
			
			$offerPropsCode = array();
			$offers = array();
			while($arOffer = $rsOffers->GetNextElement())
			{
				$arProps = $arOffer->GetProperties(); 
				$arFields = $arOffer->GetFields(); 
				
				$tempArray["ID"] = $arFields["ID"];
				$tempArray["IBLOCK_ID"] = $arFields["IBLOCK_ID"];				
				$tempArray["DISPLAY_PROPERTIES"] = $arProps;
				$offers[] = $tempArray;

				if (!$offerPropsCode)
				{
					foreach($arProps as $pr){
						if ($pr["CODE"] != "MORE_PHOTO" && $pr["CODE"] != "CML2_LINK") $offerPropsCode[]	= $pr["CODE"];
					}
				}
			}

			$arSKU = CCatalogSKU::GetInfoByProductIBlock($IBLOCK_ID);
			$arSKUPropList = CIBlockPriceTools::getTreeProperties(
				$arSKU,
				$offerPropsCode,
				array()
			);			
			$arSKUPropIDs = array_keys($arSKUPropList);

			$arResultSKUPropIDs = array();
			$arFilterProp = array();
			$arNeedValues = array();
			foreach ($offers as &$arOffer)
			{
				foreach ($arSKUPropIDs as &$strOneCode)
				{
					if (isset($arOffer['DISPLAY_PROPERTIES'][$strOneCode]))
					{
						$arResultSKUPropIDs[$strOneCode] = true;
						if (!isset($arNeedValues[$arSKUPropList[$strOneCode]['ID']]))
							$arNeedValues[$arSKUPropList[$strOneCode]['ID']] = array();
						$valueId = (
							$arSKUPropList[$strOneCode]['PROPERTY_TYPE'] == Iblock\PropertyTable::TYPE_LIST
							? $arOffer['DISPLAY_PROPERTIES'][$strOneCode]['VALUE_ENUM_ID']
							: $arOffer['DISPLAY_PROPERTIES'][$strOneCode]['VALUE']
						);
						$arNeedValues[$arSKUPropList[$strOneCode]['ID']][$valueId] = $valueId;
						unset($valueId);
						if (!isset($arFilterProp[$strOneCode]))
							$arFilterProp[$strOneCode] = $arSKUPropList[$strOneCode];
					}
				}
				unset($strOneCode);
			}

			CIBlockPriceTools::getTreePropertyValues($arSKUPropList, $arNeedValues);
			
			$firstCode = "";
			$firstPropVal = "";
			foreach($arSKUPropList as $key=>$propList){
				$firstCode = $key;
				foreach($propList["VALUES"] as $val)
				{
					$firstPropVal = $val["NAME"];
					break;
				}
				break;
			}
			
			$firstItemId = "";
			if ($firstCode && $firstPropVal)
			{
				foreach($offers as $offer)
				{
					if ($offer["DISPLAY_PROPERTIES"][$firstCode]["VALUE"] == $firstPropVal)
					{
						$firstItemId = $offer["ID"];
						break;
					}						
				}
			}
			
			unset($offers);
			unset($arSKUPropList);
			
			if ($firstItemId) $arProductID = $firstItemId;
			if (!$arProductID) $arProductID = array($ELEMENT_ID);
		}
		else $arProductID = $ELEMENT_ID;

		$sortPrice = false;
		//Get prices
		$rsPrices = CPrice::GetList(
			array(),
			array(
			"PRODUCT_ID" => $arProductID,
			)
		);


		if($arPrice = $rsPrices->Fetch())
		{
			if (CModule::IncludeModule('currency') && $strDefaultCurrency != $arPrice['CURRENCY'])
			$arPrice["PRICE"] = CCurrencyRates::ConvertCurrency($arPrice["PRICE"], $arPrice["CURRENCY"], $strDefaultCurrency);

			$PRICE = $arPrice["PRICE"];
			
			
			if ($OFFERS_IBLOCK_ID)
			{
				$res = CCatalogMeasureRatio::getList(Array(), array('IBLOCK_ID'=>$OFFERS_IBLOCK_ID, 'PRODUCT_ID'=>$arProductID), false, false, array());
				if ($ar_fields = $res->Fetch())
				{
					if ($ar_fields['RATIO']!=0) $PRICE = $PRICE * $ar_fields['RATIO'];
				}
			}
			
			if($sortPrice === false || $PRICE >0) $sortPrice = $PRICE;
			
			//Save found minimal price into property
			if($sortPrice !== false)
			{
				CIBlockElement::SetPropertyValuesEx(
					$ELEMENT_ID,
					$IBLOCK_ID,
					array(
						"SORT_PRICE" => $sortPrice,
					)
				);
			}
		}
	}
}
}


\Bitrix\Main\EventManager::getInstance()->addEventHandlerCompatible('iblock', 'OnAfterIBlockElementAdd', 'customEditElementCode');
\Bitrix\Main\EventManager::getInstance()->addEventHandlerCompatible('iblock', 'OnAfterIBlockElementUpdate', 'customEditElementCode');

/**
 * Формирование символьного кода для SEO
 * @param $fields
 */
function customEditElementCode($fields)
{
    if ($fields['RESULT'] == true && $fields['IBLOCK_ID'] == '10' && empty($fields['CODE'])) {
        \Bitrix\Main\Loader::includeModule('iblock');
        $brand_id = '';
        $brand = '';
        if (is_array($fields['PROPERTY_VALUES'][19])) {
            foreach ($fields['PROPERTY_VALUES'][19] as $v) {
                if (!empty($v['VALUE'])) {
                    $brand_id = $v['VALUE'];
                }
            }
        } else {
            $res = \CIBlockElement::GetList([], ['IBLOCK_ID' => 10, 'ID' => $fields['ID']], false, false, ['ID', 'PROPERTY_19']);
            $brand_id = $res->Fetch()['PROPERTY_19_VALUE'];
        }
        $brand_id = (int) $brand_id;

        if (!empty($brand_id)) {
            $brand = Iblock\ElementTable::query()
                ->addFilter('=ID', $brand_id)
                ->addSelect('NAME')
                ->setLimit(1)
                ->exec()
                ->fetch()['NAME'];
        }

        $section_id = '';
        $section = '';
        $section_id = Iblock\ElementTable::query()
            ->addFilter('=ID', $fields['ID'])
            ->addSelect('IBLOCK_SECTION_ID')
            ->setLimit(1)
            ->exec()
            ->fetch()['IBLOCK_SECTION_ID'];
        if (!empty($section_id)) {
            $section = Iblock\SectionTable::query()
                ->addFilter('=ID', $section_id)
                ->addSelect('NAME')
                ->setLimit(1)
                ->exec()
                ->fetch()['NAME'];
        }

        $code = implode('-', [$brand, $section, $fields['ID']]);
        $code = trim($code, '-');
        $code = \CUtil::translit($code, 'ru', ['replace_space' => '-', 'replace_other' => '-']);
        if ($fields['CODE'] != $code) {
            $el = new \CIBlockElement();
            $el->Update($fields['ID'], ['CODE' => $code]);
        }
    }
}